clear all; close all; clc
Ts=4;
del1=27;%retardos de los sistemas
del2=28;
del3=23;
del4=18;
del5=14;
del6=15;
del7=20;
del8=22;
sisy1u1=c2d(tf([0 4.05],[50 1],'inputdelay',del1),Ts,'zoh');%27
sisy1u2=c2d(tf([0 1.77],[60 1],'inputdelay',del2),Ts,'zoh');%28
sisy1u3=c2d(tf([0 2.88],[50 1],'inputdelay',del3),Ts,'zoh');%23
sisy2u1=c2d(tf([0 5.39],[50 1],'inputdelay',del4),Ts,'zoh');%18
sisy2u2=c2d(tf([0 5.72],[60 1],'inputdelay',del5),Ts,'zoh');%14
sisy2u3=c2d(tf([0 6.90],[40 1],'inputdelay',del6),Ts,'zoh');%15
sisy3u1=c2d(tf([0 4.38],[33 1],'inputdelay',del7),Ts,'zoh');%20
sisy3u2=c2d(tf([0 4.42],[44 1],'inputdelay',del8),Ts,'zoh');%22
sisy3u3=c2d(tf([0 7.20],[19 1]),Ts,'zoh');
[numy1u1 deny1u1]=tfdata(sisy1u1,'v');
[numy1u2 deny1u2]=tfdata(sisy1u2,'v');
[numy1u3 deny1u3]=tfdata(sisy1u3,'v');
[numy2u1 deny2u1]=tfdata(sisy2u1,'v');
[numy2u2 deny2u2]=tfdata(sisy2u2,'v');
[numy2u3 deny2u3]=tfdata(sisy2u3,'v');
[numy3u1 deny3u1]=tfdata(sisy3u1,'v');
[numy3u2 deny3u2]=tfdata(sisy3u2,'v');
[numy3u3 deny3u3]=tfdata(sisy3u3,'v');
Sy1u1=step(sisy1u1);
Sy1u2=step(sisy1u2);
Sy1u3=step(sisy1u3);
Sy2u1=step(sisy2u1);
Sy2u2=step(sisy2u2);
Sy2u3=step(sisy2u3);
Sy3u1=step(sisy3u1);
Sy3u2=step(sisy3u2);
Sy3u3=step(sisy3u3);
Sy1u1=Sy1u1(2:end);
Sy1u2=Sy1u2(2:end);
Sy1u3=Sy1u3(2:end);
Sy2u1=Sy2u1(2:end);
Sy2u2=Sy2u2(2:end);
Sy2u3=Sy2u3(2:end);
Sy3u1=Sy3u1(2:end);
Sy3u2=Sy3u2(2:end);
Sy3u3=Sy3u3(2:end);
Ny1=max([length(Sy1u1) length(Sy1u2) length(Sy1u3)]);
Ny2=max([length(Sy2u1) length(Sy2u2) length(Sy2u3)]);
Ny3=max([length(Sy3u1) length(Sy3u2) length(Sy3u3)]);
Sy1u1(end:Ny1,1)=Sy1u1(end);
Sy1u2(end:Ny1,1)=Sy1u2(end);
Sy1u3(end:Ny1,1)=Sy1u3(end);
Sy2u1(end:Ny2,1)=Sy2u1(end);
Sy2u2(end:Ny2,1)=Sy2u2(end);
Sy2u3(end:Ny2,1)=Sy2u3(end);
Sy3u1(end:Ny3,1)=Sy3u1(end);
Sy3u2(end:Ny3,1)=Sy3u2(end);
Sy3u3(end:Ny3,1)=Sy3u3(end);
Sy1=[Sy1u1 Sy1u2 Sy1u3];
Sy2=[Sy2u1 Sy2u2 Sy2u3];
Sy3=[Sy3u1 Sy3u2 Sy3u3];
Su=[Sy1; Sy2; Sy3];
%==========================================================================
%                               Parmetros
%==========================================================================
instantes=100;%nmero de veces que se ejecutar el algoritmo DMC
Ncu1=5; %horizontes de control
Ncu2=6;
Ncu3=7;
Npy1=Ny1+max([Ncu1 Ncu2 Ncu3]);%horizontes de prediccin
Npy2=Ny2+max([Ncu1 Ncu2 Ncu3]);
Npy3=Ny3+max([Ncu1 Ncu2 Ncu3]);
alfay1=3;%parmetros alfa lambda y W
alfay2=5;
alfay3=15;
lambdau1=1;
lambdau2=1;
lambdau3=1;
y1min=-0.51;%lmites mximos y mnimos de las VC
y1max= 0.51;
y2min=-0.31;
y2max= 0.31;
y3min=-0.15;
y3max= 0.15;
u1min=-0.2;%lmites mximos y mnimos y de incrementos de las VM
u1max= 0.2;
u2min=-0.2;
u2max= 0.2;
u3min=-0.2;
u3max= 0.2;
deltau1min=-0.02;
deltau1max= 0.02;
deltau2min=-0.02;
deltau2max= 0.02;
deltau3min=-0.02;
deltau3max= 0.02;
ry1=0.49;%referencias
ry2=0.3;
ry3=0.1399;
%==========================================================================
%                      Parmetros del algoritmo QP
%==========================================================================
rhoy1=100000;
rhoy2=100000;
rhoy3=100000;
%==========================================================================
%                       Clculo de la matriz G
%==========================================================================
Nc=[Ncu1 Ncu2 Ncu3];
G=zeros(1,sum(Nc));
for i=1:3
    switch i;
        case 1
            Np=Npy1;
            N=Ny1;
            S=Sy1;
        case 2
            Np=Npy2;
            N=Ny2;
            S=Sy2;
        case 3
            Np=Npy3;
            N=Ny3;
            S=Sy3;
    end
    if Np<=N;
        Saux=S(1:Np,:);
    else
        Saux=[S; ones(Np-N,3)*[S(end,1) 0 0; 0 S(end,2) 0; 0 0 S(end,3)]];
    end
    Gaux=zeros(Np,sum(Nc));
    k=0;
    for j=1:3
        for i=1:Nc(j);
            Gaux(i:end,k+i)=Saux(1:Np-i+1,j);
        end
        k=sum(Nc(1:j));
    end
    G=[G;Gaux];
end
G=G(2:end,:);
%==========================================================================
%                Clculo de las matrices alfa y lambda
%==========================================================================
alfa=blkdiag(alfay1*eye(Npy1,Npy1),alfay2*eye(Npy2,Npy2),alfay3*eye(Npy3,Npy3));
lambda=blkdiag(lambdau1*eye(Ncu1,Ncu1),lambdau2*eye(Ncu2,Ncu2),lambdau3*eye(Ncu3,Ncu3));
%==========================================================================
%               Clculo de las matrices Q1 y Q2
%==========================================================================
Q1y1=zeros(Ny1,Ny1);
Q1y1(1:end-1,2:end)=eye(Ny1-1,Ny1-1);
Q1y1(end,end)=1;
Q1y2=zeros(Ny2,Ny2);
Q1y2(1:end-1,2:end)=eye(Ny2-1,Ny2-1);
Q1y2(end,end)=1;
Q1y3=zeros(Ny3,Ny3);
Q1y3(1:end-1,2:end)=eye(Ny3-1,Ny3-1);
Q1y3(end,end)=1;
Q1=blkdiag(Q1y1,Q1y2,Q1y3);
Q2=0;
for i=1:3;
    switch i
        case 1
            Np=Npy1;
            N=Ny1;
            Q2aux1=Q1y1;
        case 2
            Np=Npy2;
            N=Ny2;
            Q2aux1=Q1y2;
        case 3
            Np=Npy3;
            N=Ny3;
            Q2aux1=Q1y3;
    end
    Q2aux2=zeros(Np,N);
    if Np==N;
        Q2aux2=Q2aux1;
    elseif Np<N
        Q2aux2(1:end,2:Np+1)=eye(Np,Np);
    else
        Q2aux2(1:N-1,2:end)=eye(N-1,N-1);
        Q2aux2(N:end,end)=1;
    end
    Q2=blkdiag(Q2,Q2aux2);
end
Q2=Q2(2:end,2:end);
%==========================================================================
%                       Matrices para el algoritmo QP             
%==========================================================================
I1=zeros(3,Ncu1+Ncu2+Ncu3);
H=[[G'*alfa*G+lambda,I1'];[I1,[rhoy1 0 0;0 rhoy2 0;0 0 rhoy3]]];
H=(H+H')/2;
Ia=zeros(Ncu1+Ncu2+Ncu3,3);
Ib=blkdiag(-ones(Npy1,1),-ones(Npy2,1),-ones(Npy3,1));
I=eye(Ncu1+Ncu2+Ncu3);
IL=tril(ones(Ncu1+Ncu2+Ncu3));
A1=[[I; -I],[Ia; Ia]];
A2=[[IL; -IL], [Ia;Ia]];
A3=[[G; -G],[Ib;Ib]];
A=[A1; A2; A3; [Ia',-eye(3,3)]];
B1=[ones(Ncu1,1)*deltau1max;ones(Ncu2,1)*deltau2max;ones(Ncu3,1)*deltau3max;...
  -[ones(Ncu1,1)*deltau1min;ones(Ncu2,1)*deltau2min;ones(Ncu3,1)*deltau3min]];
urest=[u1max*ones(Ncu1,1);  u2max*ones(Ncu2,1);  u3max*ones(Ncu3,1);...
      -u1min*ones(Ncu1,1); -u2min*ones(Ncu2,1); -u3min*ones(Ncu3,1)];
yrest=[y1max*ones(Npy1,1);  y2max*ones(Npy2,1);  y3max*ones(Npy3,1);...
      -y1min*ones(Npy1,1); -y2min*ones(Npy2,1); -y3min*ones(Npy3,1)];
Caux=-G'*alfa;
%==========================================================================
%                             condiciones iniciales
%==========================================================================
t=(0:1:instantes);%vector de tiempo total
deltau1vec=0;
deltau2vec=0;
deltau3vec=0;
u1vec=0;%vector que contendra las entadas aplicadas al sistema
u2vec=0;
u3vec=0;
ym1vec=0;%salida en el instante actual
ym2vec=0;
ym3vec=0;
yp1vec=0;%vector que contendra las salidas predicha de cada instante
yp2vec=0;
yp3vec=0;
zy1u1=0;%cond. iniciales para poder simular los sistemas mediante el comando filter
zy1u2=0;
zy1u3=0;
zy2u1=0;
zy2u2=0;
zy2u3=0;
zy3u1=0;
zy3u2=0;
zy3u3=0;
rety1u1=zeros(1,round(del1/Ts));%vectores para tener en cuenta los retardos de los sistemas para poder simular los sistemas mediante el comando filter
rety1u2=zeros(1,round(del2/Ts));
rety1u3=zeros(1,round(del3/Ts));
rety2u1=zeros(1,round(del4/Ts));
rety2u2=zeros(1,round(del5/Ts));
rety2u3=zeros(1,round(del6/Ts));
rety3u1=zeros(1,round(del7/Ts));
rety3u2=zeros(1,round(del8/Ts));
Ry1=ry1*ones(instantes+Npy1,1);%vectores de referencias
Ry2=ry2*ones(instantes+Npy2,1);
Ry3=ry3*ones(instantes+Npy3,1);
L=[ym1vec*ones(Ny1,1);ym2vec*ones(Ny2,1);ym3vec*ones(Ny3,1)];%inicializacion de la resuesta libre
%==========================================================================
%                       Ejecucin del algoritmo QDMC
%==========================================================================
for i=1:instantes; 
    L=Q1*L+Su*[deltau1vec(end);deltau2vec(end);deltau3vec(end)];%actualizacin de la rta libre
    w=[(ym1vec(end)-L(1))*ones(Npy1,1);...
       (ym2vec(end)-L(Ny1+1))*ones(Npy2,1);...
       (ym3vec(end)-L(Ny1+Ny2+1))*ones(Npy3,1)];%estimacin de la perturbacin no medible
    T=Q2*L+w;
    R=[Ry1(i:i+Npy1-1,1); Ry2(i:i+Npy2-1,1); Ry3(i:i+Npy3-1,1)];
    D=R-T;     
    a=[u1vec(end)*ones(Ncu1,1);  u2vec(end)*ones(Ncu2,1);  u3vec(end)*ones(Ncu3,1)];
    B2=urest+[-a;a];                
    B3=yrest+[-T;T];
    B=[B1;B2;B3;0;0;0];
    C=[Caux*D;0;0;0];
    x=QUADPROG(H,C,A,B);%clculo del vector de incrementos en la accion de control
    deltau=x(1:end-3);
    %==========================================================================
    %==========================================================================  
    yp=T+G*deltau;%salida predicha
    yp1vec(i+1)=yp(1);%salida predicha del instante Yp(k+1|k)
    yp2vec(i+1)=yp(Npy1+1);%salida predicha del instante Yp(k+1|k)
    yp3vec(i+1)=yp(Npy1+Npy2+1);%salida predicha del instante Yp(k+1|k)
    deltau1vec(i+1)=deltau(1);%deltau del instante deltau(k|k) 
    deltau2vec(i+1)=deltau(Ncu1+1);%deltau del instante deltau(k|k) 
    deltau3vec(i+1)=deltau(Ncu1+Ncu2+1);%deltau del instante deltau(k|k) 
    u1vec(i+1)=u1vec(end)+deltau(1);%accion de control del instante u(k|k)
    u2vec(i+1)=u2vec(end)+deltau(Ncu1+1);%accion de control del instante u(k|k)
    u3vec(i+1)=u3vec(end)+deltau(Ncu1+Ncu2+1);%accion de control del instante u(k|k)
    %==========================================================================
    %       aplicacion de los incrementos y medicin de la salida
    %==========================================================================    
    [y1_,zy1u1]=filter(numy1u1(1:end),deny1u1,u1vec(end),zy1u1);
    [y2_,zy1u2]=filter(numy1u2(1:end),deny1u2,u2vec(end),zy1u2);
    [y3_,zy1u3]=filter(numy1u3(1:end),deny1u3,u3vec(end),zy1u3);
    rety1u1=[y1_ rety1u1(1:end-1)];
    rety1u2=[y2_ rety1u2(1:end-1)];
    rety1u3=[y3_ rety1u3(1:end-1)];
    ym1vec(i+1)=rety1u1(end)+rety1u2(end)+rety1u3(end);
    
    [y1_,zy2u1]=filter(numy2u1(1:end),deny2u1,u1vec(end),zy2u1);
    [y2_,zy2u2]=filter(numy2u2(1:end),deny2u2,u2vec(end),zy2u2);
    [y3_,zy2u3]=filter(numy2u3(1:end),deny2u3,u3vec(end),zy2u3);
    rety2u1=[y1_ rety2u1(1:end-1)];
    rety2u2=[y2_ rety2u2(1:end-1)];
    rety2u3=[y3_ rety2u3(1:end-1)];    
    ym2vec(i+1)=rety2u1(end)+rety2u2(end)+rety2u3(end);
    
    [y1_,zy3u1]=filter(numy3u1(1:end),deny3u1,u1vec(end),zy3u1);
    [y2_,zy3u2]=filter(numy3u2(1:end),deny3u2,u2vec(end),zy3u2);
    [y3_,zy3u3]=filter(numy3u3(2:end),deny3u3,u3vec(end),zy3u3);
    rety3u1=[y1_ rety3u1(1:end-1)];
    rety3u2=[y2_ rety3u2(1:end-1)];
    rety3u3=y3_;
    ym3vec(i+1)=rety3u1(end)+rety3u2(end)+rety3u3(end);
end
Ry1=Ry1(1:instantes+1);
Ry2=Ry2(1:instantes+1);
Ry3=Ry3(1:instantes+1);
deltau1vec=deltau1vec(2:end);
deltau2vec=deltau2vec(2:end);
deltau3vec=deltau3vec(2:end);
u1vec=u1vec(2:end);
u2vec=u2vec(2:end);
u3vec=u3vec(2:end);
%==========================================================================
%                        Grficas de las variables
%==========================================================================
t2=[t(1) t(end)];
figure()
plot(t,ym1vec,'b',t,ym2vec,'r',t,ym3vec,'g');
hold on
stairs(t,yp1vec,'b');
stairs(t,yp2vec,'r');
stairs(t,yp3vec,'g');
stairs(t,Ry1,'--b');
stairs(t,Ry2,'--r');
stairs(t,Ry3,'--g');
%plot(t2,[1 1]*y1max,':b', t2, [1 1]*y2max,':r',t2,[1 1]*y3max,':g');
%plot(t2,[1 1]*y1min,':b', t2, [1 1]*y2min,':r',t2,[1 1]*y3min,':g');
hold off
title('Salidas')
xlabel('Instantes')
legend('Y1','Y2','Y3')

figure()
t=t(1:end-1);
subplot(211)
stairs(t,u1vec,'b');
hold on
stairs(t,u2vec,'r');
stairs(t,u3vec,'g');
%plot(t2,[1 1]*u1max,':b', t2, [1 1]*u2max,':r',t2,[1 1]*u3max,':g');
%plot(t2,[1 1]*u1min,':b', t2, [1 1]*u2min,':r',t2,[1 1]*u3min,':g');
hold off
title('Acciones de control')
xlabel('Instantes')
legend('u1','u2','u3')
subplot(212)
stairs(t,deltau1vec,'b');
hold on
stairs(t,deltau2vec,'r');
stairs(t,deltau3vec,'g');
%plot(t2,[1 1]*deltau1max,':b', t2, [1 1]*deltau2max,':r',t2,[1 1]*deltau3max,':g');
%plot(t2,[1 1]*deltau1min,':b', t2, [1 1]*deltau2min,':r',t2,[1 1]*deltau3min,':g');
hold off
title('Incrementos en las acciones de control')
xlabel('Instantes')
legend('deltau1','deltau2','deltau3')
