function QDMC_vs_DMC_RLS_mimo()
clear all; close all; clc
Ts=4;
del1=27;%retardos de los sistemas
del2=28;
del3=23;
del4=18;
del5=14;
del6=15;
del7=20;
del8=22;
sis_y1u1=c2d(tf([0 4.05],[50 1],'inputdelay',del1),Ts,'zoh');%27
sis_y1u2=c2d(tf([0 1.77],[60 1],'inputdelay',del2),Ts,'zoh');%28
sis_y1u3=c2d(tf([0 2.88],[50 1],'inputdelay',del3),Ts,'zoh');%23
sis_y2u1=c2d(tf([0 5.39],[50 1],'inputdelay',del4),Ts,'zoh');%18
sis_y2u2=c2d(tf([0 5.72],[60 1],'inputdelay',del5),Ts,'zoh');%14
sis_y2u3=c2d(tf([0 6.90],[40 1],'inputdelay',del6),Ts,'zoh');%15
sis_y3u1=c2d(tf([0 4.38],[33 1],'inputdelay',del7),Ts,'zoh');%20
sis_y3u2=c2d(tf([0 4.42],[44 1],'inputdelay',del8),Ts,'zoh');%22
sis_y3u3=c2d(tf([0 7.20],[19 1]),Ts,'zoh');
[num_y1u1 den_y1u1]=tfdata(sis_y1u1,'v');
[num_y1u2 den_y1u2]=tfdata(sis_y1u2,'v');
[num_y1u3 den_y1u3]=tfdata(sis_y1u3,'v');
[num_y2u1 den_y2u1]=tfdata(sis_y2u1,'v');
[num_y2u2 den_y2u2]=tfdata(sis_y2u2,'v');
[num_y2u3 den_y2u3]=tfdata(sis_y2u3,'v');
[num_y3u1 den_y3u1]=tfdata(sis_y3u1,'v');
[num_y3u2 den_y3u2]=tfdata(sis_y3u2,'v');
[num_y3u3 den_y3u3]=tfdata(sis_y3u3,'v');
S_y1u1=step(sis_y1u1);
S_y1u2=step(sis_y1u2);
S_y1u3=step(sis_y1u3);
S_y2u1=step(sis_y2u1);
S_y2u2=step(sis_y2u2);
S_y2u3=step(sis_y2u3);
S_y3u1=step(sis_y3u1);
S_y3u2=step(sis_y3u2);
S_y3u3=step(sis_y3u3);
S_y1u1=S_y1u1(2:end);
S_y1u2=S_y1u2(2:end);
S_y1u3=S_y1u3(2:end);
S_y2u1=S_y2u1(2:end);
S_y2u2=S_y2u2(2:end);
S_y2u3=S_y2u3(2:end);
S_y3u1=S_y3u1(2:end);
S_y3u2=S_y3u2(2:end);
S_y3u3=S_y3u3(2:end);
n_y1=max([length(S_y1u1) length(S_y1u2) length(S_y1u3)]);
n_y2=max([length(S_y2u1) length(S_y2u2) length(S_y2u3)]);
n_y3=max([length(S_y3u1) length(S_y3u2) length(S_y3u3)]);
S_y1u1(end:n_y1,1)=S_y1u1(end);
S_y1u2(end:n_y1,1)=S_y1u2(end);
S_y1u3(end:n_y1,1)=S_y1u3(end);
S_y2u1(end:n_y2,1)=S_y2u1(end);
S_y2u2(end:n_y2,1)=S_y2u2(end);
S_y2u3(end:n_y2,1)=S_y2u3(end);
S_y3u1(end:n_y3,1)=S_y3u1(end);
S_y3u2(end:n_y3,1)=S_y3u2(end);
S_y3u3(end:n_y3,1)=S_y3u3(end);
S_y1=[S_y1u1 S_y1u2 S_y1u3];
S_y2=[S_y2u1 S_y2u2 S_y2u3];
S_y3=[S_y3u1 S_y3u2 S_y3u3];
Stotal=[S_y1; S_y2; S_y3];
%==========================================================================
%                               Parmetros
%==========================================================================
instantes=100;%nmero de veces que se ejecutar el algoritmo DMC
c_u1=5; %horizontes de control
c_u2=5;
c_u3=5;
p_y1=n_y1+c_u1+c_u2+c_u3;%horizontes de prediccin
p_y2=n_y2+c_u1+c_u2+c_u3;
p_y3=n_y3+c_u1+c_u2+c_u3;
alfa_y1=1;%parmetros alfa lambda y W
alfa_y2=1;
alfa_y3=1;
lambda_u1=1;
lambda_u2=1;
lambda_u3=1;
y1_min=-0.4;%lmites mximos y mnimos de las VC
y1_max= 0.4;
y2_min=-0.3;
y2_max= 0.3;
y3_min=-0.2;
y3_max= 0.2;
u1_min=-0.2;%lmites mximos y mnimos y de incrementos de las VM
u1_max= 0.2;
u2_min=-0.2;
u2_max= 0.2;
u3_min=-0.2;
u3_max= 0.2;
deltau1_min=-0.05;
deltau1_max= 0.05;
deltau2_min=-0.05;
deltau2_max= 0.05;
deltau3_min=-0.05;
deltau3_max= 0.05;
R_Y1=0.4;%referencias
R_Y2=0.3;
R_Y3=0.2;
%==========================================================================
%                               Parmetros QP
%==========================================================================
rho_y1=100000;
rho_y2=100000;
rho_y3=100000;
%==========================================================================
%                            Parmetros Recursivo
%==========================================================================
Q=500;%nmero de veces que se ejecuta el algoritmo recursivo para encontrar solucin
Wy=5;
Wu=10;
Wdeltau=10;
TL_u=0.01;%tolerancias de los lmites de las entradas, incrementos y salidas 
TL_deltau=0.005;
TL_y=0.0051;
%==========================================================================
%                       Clculo de la matriz G
%==========================================================================
c=[c_u1 c_u2 c_u3];
G=zeros(1,sum(c));
for i=1:3
    switch i;
        case 1
            p=p_y1;
            n=n_y1;
            S=S_y1;
        case 2
            p=p_y2;
            n=n_y2;
            S=S_y2;
        case 3
            p=p_y3;
            n=n_y3;
            S=S_y3;
    end
    if p<=n;
        Saux=S(1:p,:);
    else
        Saux=[S; ones(p-n,3)*[S(end,1) 0 0; 0 S(end,2) 0; 0 0 S(end,3)]];
    end
    Gaux=zeros(p,sum(c));
    k=0;
    for j=1:3
        for i=1:c(j);
            Gaux(i:end,k+i)=Saux(1:p-i+1,j);
        end
        k=sum(c(1:j));
    end
    G=[G;Gaux];
end
G=G(2:end,:);
%==========================================================================
%                Clculo de las matrices alfa y lambda
%==========================================================================
alfa=alfa_y1*eye(p_y1,p_y1);
alfa(end+1:end+p_y2,end+1:end+p_y2)=alfa_y2*eye(p_y2,p_y2);
alfa(end+1:end+p_y3,end+1:end+p_y3)=alfa_y3*eye(p_y3,p_y3);
lambda=lambda_u1*eye(c_u1,c_u1);
lambda(end+1:end+c_u2,end+1:end+c_u2)=lambda_u2*eye(c_u2,c_u2);
lambda(end+1:end+c_u3,end+1:end+c_u3)=lambda_u3*eye(c_u3,c_u3);
%==========================================================================
%               Clculo de las matrices M. estrella y T
%==========================================================================
M_y1_est=zeros(n_y1,n_y1);
M_y1_est(1:end-1,2:end)=eye(n_y1-1,n_y1-1);
M_y1_est(end,end)=1;
M_y2_est=zeros(n_y2,n_y2);
M_y2_est(1:end-1,2:end)=eye(n_y2-1,n_y2-1);
M_y2_est(end,end)=1;
M_y3_est=zeros(n_y3,n_y3);
M_y3_est(1:end-1,2:end)=eye(n_y3-1,n_y3-1);
M_y3_est(end,end)=1;
M_est=M_y1_est;
M_est(end+1:end+n_y2,end+1:end+n_y2)=M_y2_est;
M_est(end+1:end+n_y3,end+1:end+n_y3)=M_y3_est;
T=0;
for i=1:3;
    switch i
        case 1
            p=p_y1;
            n=n_y1;
            M=M_y1_est;
        case 2
            p=p_y2;
            n=n_y2;
            M=M_y2_est;
        case 3
            p=p_y3;
            n=n_y3;
            M=M_y3_est;
    end
    Taux=zeros(p,n);
    if p==n;
        Taux=M;
    elseif p<n
        Taux(1:end,2:p+1)=eye(p,p);
    else
        Taux(1:n-1,2:end)=eye(n-1,n-1);
        Taux(n:end,end)=1;
    end
    T(end+1:end+p,end+1:end+n)=Taux;
end
T=T(2:end,2:end);
%==========================================================================
%                       Matrices para el algoritmo QP             
%==========================================================================
options=optimset('quadprog');
options=optimset( options,'Display','off');
options=optimset(options,'LargeScale','off');
Hqdmc=[[G'*alfa*G+lambda,zeros(c_u1+c_u2+c_u3,3)];[zeros(3,c_u1+c_u2+c_u3),[rho_y1 0 0;0 rho_y2 0;0 0 rho_y3]]];
Hqdmc=(Hqdmc+Hqdmc')/2;
mA1=eye(c_u1+c_u2+c_u3,c_u1+c_u2+c_u3);
mA1=[[mA1; -mA1], zeros(2*size(mA1,1),3)];
mA2=zeros(c_u1+c_u2+c_u3,c_u1+c_u2+c_u3);
for j=1:3
    if j==1;
        a=1;
        b=c_u1;
    elseif j==2
        a=c_u1+1;
        b=c_u1+c_u2;
    else
        a=c_u1+c_u2+1;
        b=c_u1+c_u2+c_u3;
    end
    for k=a:b;
        mA2(k,a:k)=1;
    end
end
mA2=[[mA2; -mA2], zeros(2*size(mA2,1),3)];
a=zeros(p_y1+p_y2+p_y3,3);
a(1:p_y1,1)=-1;
a(p_y1+1:p_y1+p_y2,2)=-1;
a(p_y1+p_y2+1:end,3)=-1;
mA3=[[G; -G],[a;a]];
b=[[zeros(3,c_u1+c_u2+c_u3)],[-1 0 0;0 -1 0; 0 0 -1]];
mA=[mA1; mA2; mA3;b];
mB1=[ones(c_u1,1)*deltau1_max;ones(c_u2,1)*deltau2_max;ones(c_u3,1)*deltau3_max;...
     -[ones(c_u1,1)*deltau1_min;ones(c_u2,1)*deltau2_min;ones(c_u3,1)*deltau3_min]];
Urest=[u1_max*ones(c_u1,1);  u2_max*ones(c_u2,1);  u3_max*ones(c_u3,1);...
            -u1_min*ones(c_u1,1); -u2_min*ones(c_u2,1); -u3_min*ones(c_u3,1)];
Yrest=[y1_max*ones(p_y1,1); y2_max*ones(p_y2,1); y3_max*ones(p_y3,1);...
            -y1_min*ones(p_y1,1);-y2_min*ones(p_y2,1);-y3_min*ones(p_y3,1)];
mat=-G'*alfa;
%==========================================================================
%                       Matrices para el algoritmo recursivo             
%==========================================================================
H=inv(G'*alfa*G+lambda)*G'*alfa;
Pm0=inv(G'*alfa*G+lambda);
%==========================================================================
%                       Ejecucin 
%==========================================================================
modelo=1;
while modelo<3;
    %==========================================================================
    %                    condiciones iniciales
    %==========================================================================
    t_pasado=Ts*(0:1:instantes);%vector de tiempo total
    u1=0;%vector que contendra las entadas aplicadas al sistema
    u2=0;
    u3=0;
    delta=[0; 0; 0];
    deltau1=0;
    deltau2=0;
    deltau3=0;
    y1_medida=0;
    y2_medida=0;
    y3_medida=0;
    y1=0;%vector que contendra las salidas de cada instante
    y2=0;
    y3=0;
    y1_pred=0;%vector que contendra las predicciones para cada instante
    y2_pred=0;
    y3_pred=0;
    z_y1u1=0;%cond. iniciales para poder simular los sistemas mediante el comando filter
    z_y1u2=0;
    z_y1u3=0;
    z_y2u1=0;
    z_y2u2=0;
    z_y2u3=0;
    z_y3u1=0;
    z_y3u2=0;
    z_y3u3=0;
    ret_y1u1=zeros(1,round(del1/Ts));%vectores para tener en cuenta los retardos de los sistemas para poder simular los sistemas mediante el comando filter
    ret_y1u2=zeros(1,round(del2/Ts));
    ret_y1u3=zeros(1,round(del3/Ts));
    ret_y2u1=zeros(1,round(del4/Ts));
    ret_y2u2=zeros(1,round(del5/Ts));
    ret_y2u3=zeros(1,round(del6/Ts));
    ret_y3u1=zeros(1,round(del7/Ts));
    ret_y3u2=zeros(1,round(del8/Ts));
    R_y1=R_Y1*ones(instantes+p_y1,1);%vectores de referencias
    R_y2=R_Y2*ones(instantes+p_y2,1);
    R_y3=R_Y3*ones(instantes+p_y3,1);
    libre=[y1_medida*ones(n_y1,1);y2_medida*ones(n_y2,1);y3_medida*ones(n_y3,1)];%inicializacion de la resuesta libre
    tstart=tic;
    for i=1:instantes;
        libre=M_est*libre+Stotal*delta;
        L=T*libre+[(y1_medida-libre(1,1))*ones(p_y1,1);...
            (y2_medida-libre(n_y1+1,1))*ones(p_y2,1);...
            (y3_medida-libre(n_y1+n_y2+1,1))*ones(p_y3,1)];
        R=[R_y1(i:i+p_y1-1,1); R_y2(i:i+p_y2-1,1); R_y3(i:i+p_y3-1,1)];
        E=R-L;    
        if modelo==1;
            %==========================================================================
            %                       Ejecucin del algoritmo QDMC
            %==========================================================================
            a=[ones(c_u1,1)*u1(1); ones(c_u2,1)*u2(1); ones(c_u3,1)*u3(1)];
            mB2=Urest+[-a;a];                
            mB3=Yrest+[-L;L];
            mB=[mB1; mB2; mB3; 0; 0; 0];
            mC=[mat*E;0;0;0];
            deltaU=QUADPROG(Hqdmc,mC,mA,mB,[],[],[],[],[],options);%clculo del vector de incrementos en la accion de control
            deltaU=deltaU(1:end-3);
            %==========================================================================
            %==========================================================================
        else
            %====================================================================================================
            % aplicacin del algoritmo recursivo
            %================================================================================================           
            deltaU=H*E;
            cont=0;
            Pm=Pm0;
            while (cont<Q)
                pred=L+G*deltaU;%salida predicha
                u1_fut=u1(1)+cumsum(deltaU(1:c_u1));
                u2_fut=u2(1)+cumsum(deltaU(c_u1+1:c_u1+1:c_u1+c_u2));
                u3_fut=u3(1)+cumsum(deltaU(c_u1+c_u2+1:end));
                flagu1=verificar(u1_fut,u1_max,u1_min);
                flagu2=verificar(u2_fut,u2_max,u2_min);
                flagu3=verificar(u3_fut,u3_max,u3_min);
                flagdeltau1=verificar(deltaU(1:c_u1)         ,deltau1_max,deltau1_min);
                flagdeltau2=verificar(deltaU(c_u1+1:c_u1+c_u2),deltau2_max,deltau2_min);
                flagdeltau3=verificar(deltaU(c_u1+c_u2+1:end)   ,deltau3_max,deltau3_min);
                flagpredy1=verificar(pred(1:p_y1)         ,y1_max,y1_min);
                flagpredy2=verificar(pred(p_y1+1:p_y1+p_y2),y2_max,y2_min);
                flagpredy3=verificar(pred(p_y1+p_y2+1:end)   ,y3_max,y3_min);
                if  0==sum([flagu1 flagu2 flagu3 flagdeltau1 flagdeltau2 flagdeltau3...
                        flagpredy1 flagpredy2 flagpredy3])
                    break
                end
                cont=cont+1;  
                E=0;
                h=zeros(1,c_u1+c_u2+c_u3);
                if flagu1>0
                    [E_u1,h_u1]=u_rest(flagu1,u1_fut,u1(1),u1_max,u1_min,Wu,TL_u);
                    E=[E;E_u1];
                    h(2:size(h_u1,1)+1,1:c_u1)=h_u1;
                end
                if flagu2>0
                    [E_u2,h_u2]=u_rest(flagu2,u2_fut,u2(1),u2_max,u2_min,Wu,TL_u);
                    E=[E;E_u2];
                    h(end+1:end+size(h_u2,1),c_u1+1:c_u1+c_u2)=h_u2;
                end
                if flagu3>0
                    [E_u3,h_u3]=u_rest(flagu3,u3_fut,u3(1),u3_max,u3_min,Wu,TL_u);
                    E=[E;E_u3];
                    h(end+1:end+size(h_u3,1),c_u1+c_u2+1:end)=h_u3;
                end
                if flagdeltau1>0
                    [E_deltau1,h_deltau1]=deltau_rest(flagdeltau1,deltaU(1:c_u1),deltau1_max,deltau1_min,Wdeltau,TL_deltau);
                    E=[E;E_deltau1];
                    h(end+1:end+size(h_deltau1,1),1:c_u1)=h_deltau1;
                end
                if flagdeltau2>0
                    [E_deltau2,h_deltau2]=deltau_rest(flagdeltau2,deltaU(c_u1+1:c_u1+c_u2),deltau2_max,deltau2_min,Wdeltau,TL_deltau);
                    E=[E;E_deltau2];
                    h(end+1:end+size(h_deltau2,1),c_u1+1:c_u1+c_u2)=h_deltau2;
                end
                if flagdeltau3>0
                    [E_deltau3,h_deltau3]=deltau_rest(flagdeltau3,deltaU(c_u1+c_u2+1:end),deltau3_max,deltau3_min,Wdeltau,TL_deltau);
                    E=[E;E_deltau3];
                    h(end+1:end+size(h_deltau3,1),c_u1+c_u2+1:end)=h_deltau3;
                end
                if flagpredy1>0
                    [E_y1,h_y1]=pred_rest(flagpredy1,pred(1:p_y1),y1_max,y1_min,Wy,TL_y,G,L);
                    E=[E;E_y1];
                    h=[h;h_y1];
                end
                if flagpredy2>0
                    [E_y2,h_y2]=pred_rest(flagpredy2,pred(p_y1+1:p_y1+p_y2),y2_max,y2_min,Wy,TL_y,G(p_y1+1:end,:),L(p_y1+1:end));
                    E=[E;E_y2];   
                    h=[h;h_y2];
                end
                if flagpredy3>0
                    [E_y3,h_y3]=pred_rest(flagpredy3,pred(p_y1+p_y2+1:end),y3_max,y3_min,Wy,TL_y,G(p_y1+p_y2+1:end,:),L(p_y1+p_y2+1:end));
                    E=[E;E_y3]; 
                    h=[h;h_y3];
                end
                E=E(2:end);
                h=h(2:end,:)';
                m1=h'*Pm;
                m2=Pm*h*inv(m1*h+eye(size(h,2)));
                deltaU=deltaU+m2*(E-h'*deltaU);
                Pm=Pm-m2*m1;
            end
            %==========================================================================
            %==========================================================================  
        end
        %==========================================================================
        %                       Actualizacin de vectores
        %==========================================================================
        predicciones=L+G*deltaU;%salida predicha
        delta=[deltaU(1); deltaU(c_u1+1); deltaU(c_u1+c_u2+1)];
        u1=[u1(1)+delta(1) u1];
        u2=[u2(1)+delta(2) u2];
        u3=[u3(1)+delta(3) u3];
        %==========================================================================
        %       aplicacion de los incrementos y medicin de la salida
        %==========================================================================     
        [y1_,z_y1u1]=filter(num_y1u1(1:end),den_y1u1,u1(1),z_y1u1);
        [y2_,z_y1u2]=filter(num_y1u2(1:end),den_y1u2,u2(1),z_y1u2);
        [y3_,z_y1u3]=filter(num_y1u3(1:end),den_y1u3,u3(1),z_y1u3);
        ret_y1u1=[y1_ ret_y1u1(1:end-1)];
        ret_y1u2=[y2_ ret_y1u2(1:end-1)];
        ret_y1u3=[y3_ ret_y1u3(1:end-1)];
        y1_medida=ret_y1u1(end)+ret_y1u2(end)+ret_y1u3(end);
        [y1_,z_y2u1]=filter(num_y2u1(1:end),den_y2u1,u1(1),z_y2u1);
        [y2_,z_y2u2]=filter(num_y2u2(1:end),den_y2u2,u2(1),z_y2u2);
        [y3_,z_y2u3]=filter(num_y2u3(1:end),den_y2u3,u3(1),z_y2u3);
        ret_y2u1=[y1_ ret_y2u1(1:end-1)];
        ret_y2u2=[y2_ ret_y2u2(1:end-1)];
        ret_y2u3=[y3_ ret_y2u3(1:end-1)];
        y2_medida=ret_y2u1(end)+ret_y2u2(end)+ret_y2u3(end);
        [y1_,z_y3u1]=filter(num_y3u1(1:end),den_y3u1,u1(1),z_y3u1);
        [y2_,z_y3u2]=filter(num_y3u2(1:end),den_y3u2,u2(1),z_y3u2);
        [y3_,z_y3u3]=filter(num_y3u3(2:end),den_y3u3,u3(1),z_y3u3);
        ret_y3u1=[y1_ ret_y3u1(1:end-1)];
        ret_y3u2=[y2_ ret_y3u2(1:end-1)];
        ret_y3u3=y3_;
        y3_medida=ret_y3u1(end)+ret_y3u2(end)+ret_y3u3(end);
        %==========================================================================
        %    vectores de las variables para las distintas grficas
        %==========================================================================
       if i>50&&i<=instantes
           y1_medida=y1_medida+0.002;
       end
        y1(i+1)=y1_medida;
        y2(i+1)=y2_medida;
        y3(i+1)=y3_medida;    
        y1_pred(i+1)=predicciones(1);
        y2_pred(i+1)=predicciones(p_y1+1);
        y3_pred(i+1)=predicciones(p_y1+p_y2+1);  
        deltau1(i)=delta(1);
        deltau2(i)=delta(2);
        deltau3(i)=delta(3);
    end
    R_y1=R_y1(1:instantes+1);
    R_y2=R_y2(1:instantes+1);
    R_y3=R_y3(1:instantes+1);
    u1=fliplr([u1(1) u1(1:end-1)]);
    u2=fliplr([u2(1) u2(1:end-1)]);
    u3=fliplr([u3(1) u3(1:end-1)]);
    deltau1=[deltau1 deltau1(end)];
    deltau2=[deltau2 deltau2(end)];
    deltau3=[deltau3 deltau3(end)];
    if modelo==1
        duracion=toc(tstart);
        disp( '      QP       ');
        disp(['Duracin(seg): ', num2str(duracion)]);
    else
        duracion=toc(tstart);
        disp( '    PATENTE    ');
        disp(['Duracin(seg): ', num2str(duracion)]);
    end
    %==========================================================================
    %                        Grficas de las variables
    %==========================================================================
    t=[t_pasado(1) t_pasado(end)];
    figure()
        plot(t_pasado,y1,'b',t_pasado,y2,'r',t_pasado,y3,'g');
    hold on
    %stairs(t_pasado,y1_pred,'b');
    %stairs(t_pasado,y2_pred,'r');
    %stairs(t_pasado,y3_pred,'g');
    plot(t_pasado,R_y1,'--b',t_pasado,R_y2,'--r',t_pasado,R_y3,'--g');
    %plot(t,[1 1]*y1_max,':b', t, [1 1]*y2_max,':r',t,[1 1]*y3_max,':g');
    %plot(t,[1 1]*y1_min,':b', t, [1 1]*y2_min,':r',t,[1 1]*y3_min,':g');
    hold off
    if modelo==1
        title('QDMC');
    else
        title('DMC RLS');
    end
    ylabel('salidas');
    xlabel('minutos')
    legend('Y1','Y2','Y3')

    figure()
    subplot(211)
    stairs(t_pasado,u1,'b');
    hold on
    stairs(t_pasado,u2,'r');
    stairs(t_pasado,u3,'g');
    plot(t,[1 1]*u1_max,':k', t, [1 1]*u2_max,':k',t,[1 1]*u3_max,':k');
    plot(t,[1 1]*u1_min,':k', t, [1 1]*u2_min,':k',t,[1 1]*u3_min,':k');
    ylim([min([u1_min u2_min u3_min])-0.05 max([u1_max u2_max u3_min])+0.05]);
    hold off
    if modelo==1
        title('QDMC');
    else
        title('DMC RLS');
    end
    ylabel('entradas')
    xlabel('minutos')
    legend('U1','U2','U3')
    subplot(212)
    stairs(t_pasado,deltau1,'b');
    hold on
    stairs(t_pasado,deltau2,'r');
    stairs(t_pasado,deltau3,'g');
    plot(t,[1 1]*deltau1_max,':k', t, [1 1]*deltau2_max,':k',t,[1 1]*deltau3_max,':k');
    plot(t,[1 1]*deltau1_min,':k', t, [1 1]*deltau2_min,':k',t,[1 1]*deltau3_min,':k');
    ylim([min([deltau1_min deltau2_min deltau3_min])-0.01 max([deltau1_max deltau2_max deltau3_min])+0.01]);
    hold off
    ylabel({'incrementos en';'las entradas'})
    xlabel('minutos')
    legend('deltaU1','deltaU2','deltaU3')
    %==========================================================================
    %==========================================================================
    modelo=modelo+1;
end
commandwindow
%==========================================================================
%==========================================================================
%==========================================================================
%              FUNCIONES EMPLEADAS POR EL ALGORITMO RECURSIVO
%==========================================================================
%==========================================================================
%==========================================================================
%verificar si los incrementos, entradas o predicciones violan restricciones
%==========================================================================
function flag=verificar(vector,lim_max,lim_min)
flag=0;
if min(vector)<lim_min
   flag=flag+1;
end
if max(vector)>lim_max
   flag=flag+2;
end
%==========================================================================
% Clculo de las matrices de restricciones h y Em+1 para los incrementos
%==========================================================================
function  [E,h]=deltau_rest(flag,deltau,deltau_max,deltau_min,W,tol)
h=zeros(1,length(deltau));
E=0;
switch flag
    case 1
        for j=1:length(deltau);
            if  deltau(j)<deltau_min;
                h(end+1,j)=W;
                E(end+1,1)=(deltau_min+tol)*W; 
            end   
        end
    case 2
        for j=1:length(deltau);
            if  deltau(j)>deltau_max;
                h(end+1,j)=W;
                E(end+1,1)=(deltau_max-tol)*W; 
            end                   
        end
    case 3
        for j=1:length(deltau);
            if  deltau(j)>deltau_max;
                h(end+1,j)=W;
                E(end+1,1)=(deltau_max-tol)*W; 
            end                   
            if  deltau(j)<deltau_min;
                h(end+1,j)=W;
                E(end+1,1)=(deltau_min+tol)*W; 
            end   
        end
end
h=h(2:end,:);
E=E(2:end,1);
%==========================================================================
%     Clculo de las matrices de restricciones h y Em+1 para las entradas
%==========================================================================
function  [E,h]=u_rest(flag,U_fut,U,U_max,U_min,W,tol)
a=length(U_fut);
switch flag
    case 1
        flag2=1;
        h=zeros(1,a);        
        E=(U_min+tol-U)*W;    
        k=2;
        m=1;
        for j=1:a;                
            if U_fut(j)<U_min && flag2==1;
                h(1,1:j)=W;
                flag2=2;
            elseif flag2==2
                h(k,j)=W;
                k=k+1;
            end
        end
    case 2
        flag1=1;
        h=zeros(1,a);        
        E=(U_max-tol-U)*W;   
        k=2;
        m=1;    
        for j=1:a;
            if U_fut(j)>U_max && flag1==1;
                h(1,1:j)=W;
                flag1=2;
            elseif flag1==2
                h(k,j)=W;
                k=k+1;
            end   
        end
    case 3
        flag2=1;
        flag1=1;
        h=zeros(2,a);        
        E=[U_max-tol-U;U_min+tol-U]*W;    
        k=3;
        m=2;
        for j=1:a;
            if U_fut(j)>U_max && flag1==1;
                h(1,1:j)=W;
                flag1=2;
            elseif flag1==2
                h(k,j)=W;
                k=k+1;
            end                   
            if U_fut(j)<U_min && flag2==1;
                h(m,1:j)=W;
                flag2=2;
            elseif flag2==2 && h(k-1,j)==0
                h(k,j)=W;
                k=k+1;
            end
        end
end
E=[E;zeros(size(h,1)-m,1)];
%==========================================================================
%Matrices de restricciones h y Em+1 para las predicciones en las salidas
%==========================================================================
function  [E,h]=pred_rest(flag,ypred,y_max,y_min,W,tol,G,L)
h=zeros(1,size(G,2));
E=0;
switch flag
    case 1
        for j=1:length(ypred);                
            if ypred(j)<y_min;
                h(end+1,:)=G(j,:)*W;
                E(end+1,1)=(y_min+tol-L(j))*W;
            end   
        end
    case 2
        for j=1:length(ypred);
            if ypred(j)>y_max;
                h(end+1,:)=G(j,:)*W;
                E(end+1,1)=(y_max-tol-L(j))*W; 
            end                   
        end
    case 3
        for j=1:length(ypred);
            if ypred(j)>y_max;
                h(end+1,:)=G(j,:)*W;
                E(end+1,1)=(y_max-tol-L(j))*W; 
            end                    
            if ypred(j)<y_min;
                h(end+1,:)=G(j,:)*W;
                E(end+1,1)=(y_min+tol-L(j))*W;
            end   
        end
end
h=h(2:end,:);
E=E(2:end,1);
%==========================================================================
%==========================================================================
